#version 460 core

#extension GL_EXT_buffer_reference2 : require
#extension GL_EXT_nonuniform_qualifier : require

struct Instance {
	uint material_index;
};

layout(std430, set = 0, binding = 0) readonly buffer InstanceBuffer {
	Instance instances[];
};

layout(location = 0) out uint fsMaterialIndex;

const vec2 positions[3] = vec2[](
	vec2(0.0f, -0.5f),
	vec2(0.5f, 0.5f),
	vec2(-0.5f, 0.5f)
);

const vec3 colors[3] = vec3[](
	vec3(1.0f, 0.0f, 0.0f),
	vec3(0.0f, 1.0f, 0.0f),
	vec3(0.0f, 0.0f, 1.0f)
);

void main() {
	gl_Position = vec4(positions[gl_VertexIndex], 0.0f, 1.0f);
	fsMaterialIndex = instances[gl_InstanceIndex].material_index;
}